/*
 *	main.c
 *
 *	o^ǂ
 *
 *	* Thu May 31 05:00:00 JST 2005 Naoyuki Sawa
 *	- 쐬JnB
 */
#include "app.h"

/****************************************************************************
 *	
 ****************************************************************************/

#ifdef USE_MUSIC
#include "instdef2.c"
#endif /*USE_MUSIC*/

#ifdef USE_SPRITE
#define SPRITE_ SPRITE_INIT2
const SPRITE sprite_table[SPRITE_COUNT] = {
#include "sprite.h"
};
#undef SPRITE_
#endif /*USE_SPRITE*/

#define extern
#include "work.h"
#undef extern

/****************************************************************************
 *	
 ****************************************************************************/

#define DATA_FNAME	"baratan.dat"	/* t@C */
#define MAX_WORD	10000		/* őPꐔ */

char word_tbl[MAX_WORD][6 + 1];		/* PꃊXg */
int word_cnt;				/* PꃊXg̗vf */

/****************************************************************************/

#define MAX_TIMER	SEC(60)		/* ^C}l  */
#define TIMER_Y		11		/* ^C}YW */
#define TIMER_H		 4		/* ^C}̍  */

#define BASE_X		 6		/* EChEAplAvC[ʒu̍[XW */
#define DIFF_X		20		/* EChEAplAvC[ʒuXW̊Ԋu */

#define WINDOW_Y	20		/* EChEYW */
#define PANEL_Y	 	42		/* plYW */
#define PLAYER_Y	60		/* plYW */

#define JUMP_TIME	SEC(0.5)
#define JUMP_VY		0x400
#define JUMP_G		0x180

/****************************************************************************/

/* Q[ */
int hiscore;		/* nCXRA */
int score;		/* XRA */
int timer;		/* c莞 */

/* vC[ */
int player_x;		/* XW (24.8bit) */
int player_col;		/* Jʒu */
int player_y;		/* YW (24.8bit) */
int player_vy;		/* Yx */

/*  */
int word_len;		/* 𓚂̒ */
char word[6];		/* 𓚕 (nulI[) */

/* EChE (Iϕ) */
int window_len;		/* EChE̒ */
char window[6];		/* EChE (nulI[) */
int move_x;		/* EChE̍Ō̕ړ́AȂƂꂩ0ɂȂ܂ (24.8bit) */
int move_y;		/* () */

/* pl (I𕶎) */
char panel_sel[6];	/* pl̈ړ (0=IA-1=) */
char panel[6];		/* pl (nulI[) */

int field_ofs;		/* [[ItZbg */

/****************************************************************************/

void data_init();
void word_init();
void field_disp();
int player_action(int move_ok, int sel_ok);
void player_disp();
void window_action();
void window_disp();
void panel_disp();

/****************************************************************************
 *	main
 ****************************************************************************/

int
main()
{
	/* B */
	app_init();

	/* C[vB */
	for(;;) {
		if(demo_main() < 0) break;
		game_main();
	}

	return 0;
}

/****************************************************************************
 *	app_init
 ****************************************************************************/

void
app_init()
{
	/* ʓIȏB */
	pceLCDDispStop();
#ifdef V_SCREEN
	pceLCDSetBuffer(_def_vbuff);
#else /*V_SCREEN*/
	pceLCDSetBuffer(vbuff);
#endif /*V_SCREEN*/
	pceAppSetProcPeriod(1000 / FPS);
	pcePadSetTrigMode(PP_MODE_SINGLE);
	pceLCDDispStart();

	/* `B */
	surface.w = DISP_X;
	surface.h = DISP_Y;
	surface.vbuff = vbuff;
#ifdef USE_3D
	surface.zbuff = zbuff;
	render_init_3d(&render, &surface, 0, 0, 0, 0, FRONT, BACK, FOVY);
#else /*USE_3D*/
	render_init_2d(&render, &surface, 0, 0, 0, 0);
#endif /*USE_3D*/

#if defined(TRACE_ON) && (TRACE_ON)
	/* WG[o͂J܂B */
	stderr_open(1/*WG[o̓j^ڑ҂()*/);
#endif /*TRACE_ON*/

#ifdef TURBO
	/* NbNEEFCgؑւ܂B */
	turbo(TURBO);
#endif /*TURBO*/

#ifdef USE_GC
	/* K[x[WRN^[܂B */
	gc_init();
#endif /*USE_GC*/

#ifdef LDIRECT_INTERVAL
	/* ؑցE16K\܂B */
	ldirect_init(LDIRECT_INTERVAL);
#endif /*LDIRECT_INTERVAL*/

#ifdef USE_MUSIC
	/* yCu܂B */
	music_loudness(1);
	loadInst(); /* uRandomism Zone(http://www8.plala.or.jp/randomism/)v́whFLbgver.2.10xgp */
	InitMusic();
#endif /*USE_MUSIC*/

	/* N[Abv֐o^B */
	atexit(app_exit);

	/* eNX`܂B */
#ifdef TEXTURE_LIST
	{
		typedef const unsigned char TEXTURE_DATA[];
		extern TEXTURE_DATA TEXTURE_LIST;
		texture_table_init(texture_table, sizeof texture_table / sizeof *texture_table, TEXTURE_LIST);
	}
#endif /*TEXTURE_LIST*/

#ifdef USE_SPRITE
	/* ȈՃXvCghCo܂B */
	sprite_init(&render, sprite_table, SPRITE_COUNT, texture_table, TEXTURE_COUNT);
#endif /*USE_SPRITE*/

/*{{AvP[VL̏*/
	srand(pceTimerGetCount());
	data_init();
/*}}AvP[VL̏*/
}

/****************************************************************************
 *	app_exit
 ****************************************************************************/

void
app_exit()
{
#ifdef USE_MUSIC
	/* mɉyt~܂B
	 * TEh̒~̓CupceAppExit()ōsĂ̂ŁA
	 * ł͕Kv܂B
	 */
	StopMusic();
	music_loudness(0);
#endif /*USE_MUSIC*/

#ifdef LDIRECT_INTERVAL
	/* ؑցE16K\܂B */
	ldirect_free();
#endif /*LDIRECT_INTERVAL*/

#ifdef USE_GC
	/* K[x[WRN^[܂B */
	gc_free();
#endif /*USE_GC*/
}

/****************************************************************************
 *	schedule
 ****************************************************************************/

void
schedule()
{
#ifdef QUICK_REPEAT
	static unsigned char rep[8]; /* I[gs[gJE^ */
#endif /*QUICK_REPEAT*/

	int x __attribute__((unused));
	int y __attribute__((unused));

#ifdef USE_PAUSE
	int pause;
	/* PAUSEbZ[Ẅ̃C[Wޔpobt@́A324oCgKvłB
	 * X^bNɎ̂͊댯łAstaticɎ̖̂ʂłB
	 * ŁAPAUSEɂ̂݃q[vmۂ邱Ƃɂ܂B
	 */
	//unsigned char save[PAUSE_H][PAUSE_W];
	unsigned char (*save)[PAUSE_W] = NULL/*x}*/;

	pause = 0;
	for(;;) {
#endif /*USE_PAUSE*/

#ifdef V_SCREEN
		{ /* vbuff(c)_def_vbuff()ϊ */
			unsigned char *dst, *src;
			dst = &_def_vbuff[0];     /* ]̉ʂ͍ォ瑖Jn܂ */
			src = &vbuff[DISP_X - 1]; /* ]̏cʂ͉Eォ瑖Jn܂ */
			for(x = DISP_X - 1; x >= 0; x--) {
				for(y = 0; y < DISP_Y; y++) {
					*dst = *src;
					dst += 1;      /* ʂEɑ܂ */
					src += DISP_X; /* cʂɑ܂ */
				}
				                            /* ʂ͊Ɏ̍sֈړĂ܂ */
				src -= DISP_X * DISP_Y + 1; /* cʂ̗̈ԏֈړ܂ */
			}
		}
#endif /*V_SCREEN*/
		pceLCDTrans();		/* ʍXV */
		yield();		/* VXe */
		joy = pcePadGet();	/* pbhԍXV */
#ifdef V_SCREEN
		joy = (joy & ~(PAD_LF | PAD_RI | PAD_UP | PAD_DN | /* cʗp͕ϊ */
			       TRG_LF | TRG_RI | TRG_UP | TRG_DN))
			| (joy & PAD_LF ? PAD_UP : 0)
			| (joy & PAD_RI ? PAD_DN : 0)
			| (joy & PAD_UP ? PAD_RI : 0)
			| (joy & PAD_DN ? PAD_LF : 0)
			| (joy & TRG_LF ? TRG_UP : 0)
			| (joy & TRG_RI ? TRG_DN : 0)
			| (joy & TRG_UP ? TRG_RI : 0)
			| (joy & TRG_DN ? TRG_LF : 0);
#endif /*V_SCREEN*/

#ifdef USE_PAUSE
		/* PAUSEB */
		if(joy & TRG_START) {
			pause = !pause;	/* PAUSEԐ؂ւ */
			if(pause) {	/* PAUSE IN */
				/* PAUSEbZ[W\̃C[WޔB */
				save = (unsigned char (*)[PAUSE_W])malloc(PAUSE_W * PAUSE_H); /* C[Wޔpobt@m */
				if(save == NULL) DIE();
				for(y = 0; y < PAUSE_H; y++) {
					for(x = 0; x < PAUSE_W; x++) {
						save[y][x] = vbuff[DISP_X * (PAUSE_Y + y) + (PAUSE_X + x)];
					}
				}
			} else {	/* PAUSE OUT */
				/* PAUSEbZ[W\̃C[W𕜋AB */
				for(y = 0; y < PAUSE_H; y++) {
					for(x = 0; x < PAUSE_W; x++) {
						vbuff[DISP_X * (PAUSE_Y + y) + (PAUSE_X + x)] = save[y][x];
					}
				}
				free(save); /* C[Wޔpobt@J */
			}
		}
		if(!pause) break;

		/* PAUSEbZ[W_ŕ\B */
		if(pceTimerGetCount() % 1000 < 750) {
			render_string_framed(&render, PAUSE_X, PAUSE_Y, PAUSE_STR, PAUSE_FONT, PAUSE_COLOR);
		} else {
			for(y = 0; y < PAUSE_H; y++) {
				for(x = 0; x < PAUSE_W; x++) {
					vbuff[DISP_X * (PAUSE_Y + y) + (PAUSE_X + x)] = save[y][x];
				}
			}
		}
	}
#endif /*USE_PAUSE */

#ifdef QUICK_REPEAT
	/* I[gs[gB */
	for(x = 0; x < 8; x++) {
		y = 1 << x; /* PAD_* */
		if(QUICK_REPEAT_PADS & y) {
			if(joy & y) {
				if(rep[x] != 0xff) rep[x]++;
				if(rep[x] >= QUICK_REPEAT_DELAY) joy |= y << 8; /* TRG_* */
			} else {
				rep[x] = 0;
			}
		}
	}
#endif QUICK_REPEAT

	now++;	/* O[o^C}XV */
}

/****************************************************************************
 *	delay
 ****************************************************************************/

void
delay(int frame)
{
	while(frame > 0) {
		schedule();
		frame--;
	}
}

/****************************************************************************
 *	demo_main
 ****************************************************************************/

int
demo_main()
{
	for(;;) {
		schedule();

		/* ^Cg\B */
		sprite_draw(0, 0, SPR_TITLE, 0);
		render_string_framed(&render, (DISP_X - 4 * 10) / 2 - 1, 58, " A : START", 0x82, 0x330);
		render_string_framed(&render, (DISP_X - 4 * 10) / 2 - 1, 66, "SEL: EXIT ", 0x82, 0x330);

		render_printf_framed(&render, 0, 0, 0x82, 0x221, "HISCORE %02d", hiscore);
		render_printf_framed(&render, 0, 0, 0x82, 0x330, "HISCORE %2d" , hiscore);
		render_printf_framed(&render, DISP_X - 4 * 8 - 1, 0, 0x82, 0x221, "SCORE %02d", score);
		render_printf_framed(&render, DISP_X - 4 * 8 - 1, 0, 0x82, 0x330, "SCORE %2d" , score);

		/* JnAI? */
		if(joy & TRG_A) {
			break;
		}
		if(joy & TRG_SELECT) {
			return -1;
		}
	}

	return 0;
}

/****************************************************************************
 *	game_main
 ****************************************************************************/

static int
check_word()
{
	int i;

	/* z肵PƓȂAOKB */
	if(memcmp(window, word, word_len) == 0) {
		return 1;
	}

	/* ꂩ̒PɈvAOKB */
	for(i = 0; i < word_cnt; i++) {
		if((strlen(word_tbl[i]) == word_len) &&
		   (memcmp(window, word_tbl[i], word_len) == 0)) {
			return 1;
		}
	}

	return 0;
}

void
game_main()
{
	int i;

	score = 0;
	timer = MAX_TIMER;

	player_col = 0;
	player_x   = DISP_X   << 8;
	player_y   = PLAYER_Y << 8;
	player_vy  = 0;

	word_len = 0;
	window_len = 0;
	memset(panel_sel, -1, sizeof panel_sel);
	for(i = 0; i < SEC(1.0); i++) {
		schedule();
		field_disp();
		render_printf(&render, 0, 0, 0x80, 3, "READY?");
		if((i >= SEC(0.25)) && (joy & TRG_AB)) {
			break;
		}
	}

	for(;;) {
		/* 菉B */
		word_init();

		/* ploB */
		field_ofs = 128;
		do {
			schedule();
			//
			if(joy & TRG_AB) {
				break;
			}
			player_action(1, 0);
			window_action();
			field_disp();
			render_printf(&render, 0, 0, 0x80, 3, "AorB:");
			//
			field_ofs -= 5;
		} while(field_ofs > 0);
		field_ofs = 0;

		for(;;) {
			schedule();
			//
			if(player_action(1, 1)) { /* ? */
				break;
			}
			window_action();
			//
			field_disp();
			//
			if(window_len < word_len) {
				render_printf(&render, 0, 0, 0x80, 3, "A:I B:߂");
			} else {
				render_printf(&render, 0, 0, 0x80, 3, "A: B:߂");
			}
			//
			timer--;
			if(timer <= 0) {
				goto GAMEOVER;
			}
		}

		/* B */
		if(check_word()) { /*  */
			score++;
			for(i = 0; i < SEC(3); i++) {
				schedule();
				player_action(1, 0);
				window_action();
				field_disp();
				sprite_draw(0, 0, SPR_GOOD, 0);
				render_printf(&render, 0, 0, 0x80, 3, "!", word_len, word);
				if((i >= SEC(0.25)) && (joy & TRG_AB)) {
					break;
				}
			}
		} else { /* s */
			for(i = 0; i < SEC(3); i++) {
				schedule();
				player_action(1, 0);
				window_action();
				field_disp();
				sprite_draw(0, 0, SPR_BAD, 0);
				render_printf(&render, 0, 0, 0x80, 3, ":%.*s", word_len, word);
				if((i >= SEC(0.25)) && (joy & TRG_AB)) {
					break;
				}
			}
		}
	}

GAMEOVER:
	timer = 0;
	if(score > hiscore) {
		hiscore = score;
	}
	for(i = 0; i < SEC(10); i++) {
		schedule();
		player_action(0, 0);
		window_action();
		field_disp();
		sprite_draw(0, 0, SPR_GAMEOVER, 0);
		render_printf(&render, 0, 0, 0x80, 1, "HISCORE:%02d", hiscore);
		render_printf(&render, 0, 0, 0x80, 3, "HISCORE:%2d" , hiscore);
		if((i >= SEC(1)) && (joy & TRG_AB)) {
			break;
		}
	}
}

/****************************************************************************
 *	data_init
 ****************************************************************************/

void
data_init()
{
	FILE* fp;
	char str[6 + 1];
	int ch;
	int len;

	/* t@CJ܂B */
	fp = fopen(DATA_FNAME, "r");
	if(!fp) {
		die(DATA_FNAME "J܂B");
		exit(-1);
	}

	/* sǂݍ݂܂B */
	while(fgets(str, sizeof str, fp)) { /* fgetsn-1ǂ݂܂ */
		/* 𐔂ȂA->啶܂B */
		len = 0;
		for(;;) {
			ch = str[len];
			/* nul܂͉sɂI[Ȃ΁A܂B */
			if((ch == '\0') || (ch == '\r') || (ch == '\n')) {
				str[len] = '\0';
				break;
			}
			/* At@xbgȊO܂܂ĂA΂܂B */
			if(!isalpha(ch)) {
				len = 0; /* }[N */
				break;
			}
			/* mɑ啶ɂ܂B */
			ch = toupper(ch);
			str[len] = ch;
			/* JEgAbv܂B */
			len++;
		}

		/* 3`6Ȃ΁Ai[܂B */
		if((len >= 3) && (len <= 6)) {
			strcpy(word_tbl[word_cnt], str);
			/* PꐔJEgAbvAőPꐔɒBA܂B */
			word_cnt++;
			if(word_cnt == MAX_WORD) {
				break;
			}
		}
	}

	/* t@C܂B */
	fclose(fp);

	/* LȒPꂪ΁AG[I܂B */
	if(!word_cnt) {
		die(DATA_FNAME "słB");
		exit(-1);
	}
}

/****************************************************************************
 *	
 ****************************************************************************/

void
word_init()
{
	int i_word;

	/* PI܂B */
	i_word = rand() % word_cnt;

	/* PRs[܂B */
	word_len = strlen(word_tbl[i_word]);
	memcpy(word, word_tbl[i_word], word_len);

	/* EChE܂B */
	window_len = 1;
	window[0] = word[0]; /* ŏ̈ꕶ͌Œ */
	move_x = 0; /* pl[VNA */
	move_y = 0;

	/* pl܂B */
	memcpy(panel, &word[1], word_len - 1); /* 񕶎ڈȍ~plɃRs[ */
	panel[word_len - 1] = RND16_RANGE(seed, 'A', 'Z' + 1); /* _~[̈ꕶ */
	shuffle(panel, word_len, sizeof *panel, seed);
	memset(&panel_sel[       0],  0,     word_len); /* I */
	memset(&panel_sel[word_len], -1, 6 - word_len); /*  */
}

/****************************************************************************
 *	field_disp
 ****************************************************************************/

void
field_disp()
{
	int x;

	/* wi\B */
	sprite_draw(0, 0, SPR_BGB0, 0);
	sprite_draw(field_ofs      , 0, SPR_BGB1, 0);
	sprite_draw(field_ofs - 128, 0, SPR_BGB1, 0);
	sprite_draw(0, 0, SPR_BGB2, 0);

	/* EChEEpl\B */
	window_disp();
	panel_disp();

	/* Oi\B */
	sprite_draw(0, 0, SPR_BGF0, 0);

	/* vC[\B */
	player_disp();

	/* XRA\B */
	render_printf(&render, DISP_X - 5 * 8, 0, 0x80, 1, "SCORE:%02d", score);
	render_printf(&render, DISP_X - 5 * 8, 0, 0x80, 3, "SCORE:%2d" , score);

	/* ^C}\B */
	x = timer;
	if(x < 0) {
		x = 0;
	} else if(x > MAX_TIMER) {
		x = MAX_TIMER;
	}
	x = (DISP_X * x + (MAX_TIMER - 1)) / MAX_TIMER;
	render_rectangle_fill(&render, x, TIMER_Y, DISP_X - x, TIMER_H, 3);
}

/****************************************************************************
 *	player_action
 ****************************************************************************/

int
player_action(int move_ok, int sel_ok)
{
	int i;
	int x;

	if(move_ok) {
		/* vC[EړB */
		if((joy & TRG_LF) && (player_col > 0)) {
			player_col--;
		}
		if((joy & TRG_RI) && (player_col < (6 - 1))) {
			player_col++;
		}
	}

	if(sel_ok) {
		/* plIB */
		if(joy & TRG_A) {
			/* ɑSIĂAցB */
			if(window_len == word_len) {
				return 1;
			}

			/* plAIȂ... */
			if((player_col <= word_len - 1) && (!panel_sel[player_col])) {
				/* EChEɕǉAplɈړL^܂B */
				window[window_len] = panel[player_col];
				panel_sel[player_col] = window_len;
				window_len++;
				/* pl[VWݒB */
				move_x = (BASE_X + DIFF_X * player_col) << 8;
				move_y = (PANEL_Y                     ) << 8;
			}

			/* Wv[VB */
			player_y = (PLAYER_Y << 8);
			player_vy = JUMP_VY;
		}

		/* plIB */
		if(joy & TRG_B) {
			/* IȊO1ȏIς݂Ȃ... */
			if(window_len > 1) {
				/* Ō̕ɑΉpl߂܂B */
				window_len--;
				for(i = 0; i < 6; i++) {
					if(panel_sel[i] == window_len) {
						break;
					}
				}
				if(i == 6) DIE();
				panel_sel[i] = 0; /* I */
				move_x = 0; /* pl[VNA */
				move_y = 0;
			}
		}
	}

	/* vC[WړB */
	x = (BASE_X + DIFF_X * player_col) << 8;
	player_x = (player_x + x + 1) >> 1;

	/* vC[WړB */
	player_y -= player_vy;
	if(player_y >= (PLAYER_Y << 8)) {
		player_y = (PLAYER_Y << 8);
	} else {
		player_vy -= JUMP_G;
	}

	return 0;
}

/****************************************************************************
 *	player_disp
 ****************************************************************************/

void
player_disp()
{
	int x;
	int y;

	x = (player_x + 0x80) >> 8;
	y = (player_y + 0x80) >> 8;
	sprite_draw(x, y, SPR_PLAYER, 0);
}

/****************************************************************************
 *	window_action
 ****************************************************************************/

void
window_action()
{
	int x;
	int y;

	/* pl[VB */
	if(move_x || move_y) {
		x = (BASE_X + DIFF_X * (window_len - 1)) << 8;
		y = (WINDOW_Y                          ) << 8;
		move_x = (move_x + x + 1) >> 1;
		move_y = (move_y + y + 1) >> 1;
	}
}

/****************************************************************************
 *	window_disp
 ****************************************************************************/

void
window_disp()
{
	int i;
	int x;
	int y;

	x = BASE_X;
	y = WINDOW_Y;
	for(i = 0; i < window_len; i++) {
		if((i == window_len - 1) && (move_x || move_y)) { /* pl[V? */
			x = (move_x + 0x80) >> 8;
			y = (move_y + 0x80) >> 8;
		}
		sprite_draw(x, y, SPR_A + (window[i] - 'A'), 0);
		x += DIFF_X;
	}
}

/****************************************************************************
 *	panel_disp
 ****************************************************************************/

void
panel_disp()
{
	int i;
	int x;
	int y;

	x = BASE_X + field_ofs;
	y = PANEL_Y;
	for(i = 0; i < 6; i++) {
		if(!panel_sel[i]) { /* I? */
			sprite_draw(x, y, SPR_A + (panel[i] - 'A'), 0);
		}
		x += DIFF_X;
	}
}

